# AutoRest Documentation

1. Introduction
    - Get an [introduction][introduction] to the fundamental concepts of AutoRest

2. Installing AutoRest
    - You can [install AutoRest][install] on Windows, Mac, or Linux.

3. Defining Clients with OpenAPI
    - Learn [how to define your REST API][openapi] with OpenAPI

4. Generating Clients with AutoRest
    - How do I generate code? See [here][generate]

5. Using Your Generated Client
    - How do I [use my client][client] now that I've generated it?

6. Migrating from AutoRest 2.0 to 3.0
    - I have old generated code using the previous version of AutoRest. How do I [upgrade][migrate] my generation and use my new code?

7. Developing with AutoRest
    - How do I generate or contribute to AutoRest in [dev mode][dev]?

8. `Powershell` documentation
    - [How][powershell] do I use AutoRest to build `Powershell` cmdlets?

9. [Troubleshooting][troubleshooting]

10. [FAQ][faq]

<!-- LINKS -->
[introduction]: https://github.com/Azure/autorest/blob/master/docs/introduction.md
[install]: https://github.com/Azure/autorest/blob/master/docs/install/readme.md
[openapi]: https://github.com/Azure/autorest/blob/master/docs/openapi/readme.md
[generate]: https://github.com/Azure/autorest/blob/master/docs/generate/readme.md
[client]: https://github.com/Azure/autorest/blob/master/docs/client/readme.md
[migrate]: https://github.com/Azure/autorest/blob/master/docs/migrate/readme.md
[dev]: https://github.com/Azure/autorest/blob/master/docs/developer/readme.md
[powershell]: https://github.com/Azure/autorest/blob/master/docs/powershell/readme.md
[troubleshooting]: https://github.com/Azure/autorest/blob/master/docs/troubleshooting.md
[faq]: https://github.com/Azure/autorest/blob/master/docs/faq.md